unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Edit1: TEdit;
    procedure Edit1Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

var Zaehler:Integer;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  // hier zaehlen wir die Änderungen, eifvah nur um zu zeigen
  //   wann immer OnChange aufgeufen wird. Nämlich bei jedem Tastendruck
  inc(zaehler);
  Form1.caption:=IntToStr(Zaehler);  // Anzeige des Wertes

  // nun sorgen wird dafür, dass die OnPaint Funktion aufgerufen wird,
  // damit ALLES neu gezeichnet wird.
  // das tun wir mit dem Aufruf: Form1.Invalidate;
  // damit wird das Fenster für "ungültig erklärt
  // und das Programm ruft nun von selbst die Funktion OnPaint auf.
  // Dort wird dann alles neu gezeichnet.
  // Also NICHT mehr HIER zeichnen....

  Form1.invalidate;  // Der Auslöser für das Neu Zeichnen
end;

procedure TForm1.FormPaint(Sender: TObject);
var i:Integer; // Schleifenzähler für alle Linien
begin
  // nun zeichnen wir ALLES neu, die gesamten horizontalen Linien
  // welche wir mitgezählt hatten.

  // hier kannst Du zeichnen auf Teufel hinaus und zwar NUR hier

  Form1.canvas.Pen.color:=clRed;  // Stiftfarbe rot
  For i:=1 to Zaehler do
    Form1.canvas.Line(0,i,Form1.ClientWidth,i);

end;

end.

